<template>
  <div class="dialog-table-container">
    <!-- @expand-change="expandChange" -->
    <el-table
      :element-loading-background="loadingColor"
      v-loading="loading"
      height="76vh"
      align="center"
      :data="tableData"
      class="dialog_table"
      :cell-style="{'text-align': 'center'}"
      :header-cell-style="{'text-align': 'center'}"
      ref="myTable"
    >
      <el-table-column type="index" label="序号" width="50"> </el-table-column>
      <el-table-column prop="projectName" label="项目名称" width="320">
      </el-table-column>
      <el-table-column
        prop="updateNum"
        label="迭代举措数"
        show-overflow-tooltip
      >
      </el-table-column>
      <el-table-column prop="addNum" label="新增举措数" show-overflow-tooltip>
      </el-table-column>
      <el-table-column prop="iterationSn" label="排位" show-overflow-tooltip>
      </el-table-column>
      <el-table-column type="expand" width="0">
        <template>
          <div class="infoTable" element-loading-background="rgba(1,33,90,1)"
              v-loading="iterLoading">
            <el-table
              v-if="!iterLoading"
              :data="infoTableData"
              style="width: 100%"
            >
              <el-table-column type="index" label="序号" width="50" align="center">
              </el-table-column>
              <el-table-column prop="oldName" label="原举措" align="center">
                <template v-slot={row}>
                    {{row.oldName || '----'}}
                </template>
              </el-table-column>
              <el-table-column prop="newName" label="迭代后举措" align="center"> </el-table-column>
              <el-table-column prop="cause" label="迭代依据" align="center">
                <template v-slot={row}>
                    {{row.cause || '----'}}
                </template>
              </el-table-column>
              <el-table-column prop="iterType" label="迭代类型" align="center"> </el-table-column>
              <el-table-column prop="time" label="迭代时间" align="center"> </el-table-column>
            </el-table>
          </div>
        </template>
        <!-- <template slot-scope="props">
          <div class="dialog-table-expand">
            <template>
              <div class="jc-title">迭代举措：</div>
              <el-row>
                <el-card
                  class="box-card"
                  v-for="(update, index) in props.row.updateVOS"
                  :key="index"
                >
                  <div class="jc-item">原举措：{{ update.oldName }}</div>
                  <div class="jc-item">迭代后举措：{{ update.newName }}</div>
                  <div class="jc-item">迭代依据：{{ update.cause }}</div>
                </el-card>
              </el-row>
            </template>
            <template v-if="props.row.addVOS && props.row.addVOS.length">
              <div class="jc-title">新增举措：</div>
              <el-row>
                <el-card
                  class="box-card"
                  v-for="(add, index) in props.row.addVOS"
                  :key="index"
                >
                  <div class="jc-item">举措名称：{{ add.name }}</div>
                  <div class="jc-item">新增依据：{{ add.cause }}</div>
                </el-card>
              </el-row>
            </template>
          </div>
        </template> -->
      </el-table-column>
      <el-table-column label="详情" width="100">
        <template v-slot="{row, $index}">
          <el-tag
            effect="dark"
            style="cursor: pointer"
            @click="handleDetail(row, $index)"
            >查看详情
          </el-tag>
        </template>
      </el-table-column>
    </el-table>
    <!--    <pagenation @currentChange="pageChange" class="pagenation"></pagenation>-->
  </div>
</template>

<script>
import pagenation from './pagenation.vue'
import apiList from '@/api/bigScreen/majorView.js'
import moment from 'moment'
export default {
  name: 'iterationList',
  components: {pagenation},
  props: {
    tableOptions: {
      type: Object,
      default: () => {
        return {}
      }
    }
  },
  data() {
    return {
      loading: false,
      loadingColor: 'rgba(6, 46, 106, 0.4)',
      tableData: [],
      infoTableData: [],
      iterLoading: false
      //   tableData: []
    }
  },
  mounted() {
    this.loadData()
  },
  methods: {
    //--------数据-----------
    loadData() {
      this.getProjectBrand()
    },
    expandChange(row, expandedRows) {
      console.log(row, expandedRows)
    },
    handleDetail(row) {
      console.log(row);
      this.isShow = 0
      this.iterLoading = true
      if (!row.expansion) {
        apiList.getIterationList(row.projectId, res => {
          if (res) {
            res.iterationAddVO.forEach(item => {
                item.iterType = '新增举措'
                item.newName = item.name
                item.time = moment(item.time).format('YYYY-MM-DD')
            })
            res.iterationUpdateVO.forEach(item => {
                item.iterType='迭代举措'
                item.time = moment(item.time).format('YYYY-MM-DD')
            })
            this.infoTableData = [...res.iterationUpdateVO,...res.iterationAddVO]
            this.iterLoading = false
          }
        })
      }
      this.$nextTick(() => {
        let $table = this.$refs.myTable
        this.tableData.map(item => {
          if (row.projectId != item.projectId) {
            $table.toggleRowExpansion(item, false)
            item.expansion = false
          } else {
            item.expansion = !item.expansion
          }
        })
        $table.toggleRowExpansion(row)
      })
    },
    // 迭代榜
    getProjectBrand() {
      this.loading = true
      let searchDate = sessionStorage.getItem('searchDate')
      searchDate = JSON.parse(searchDate)
      let data = {
        year: searchDate.year,
        month: searchDate.month
      }
      apiList.getIteration(data, res => {
        if (res) {
          this.tableData = res
        }
        this.loading = false
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.infoTable {
  margin: -12px 0;
//   min-height: 78px;
  /*最外层透明*/
  /deep/ .el-table,
  /deep/ .el-table__expanded-cell {
    background-color: transparent;
  }
  /* 表格内背景颜色 */
  /deep/ .el-table th,
  /deep/ .el-table tr,
  /deep/ .el-table td {
    background-color: rgba(2,62,141,1);
  }
  /deep/.el-table::before {
    left: 0;
    bottom: 0;
    width: 100%;
    height: 0px;
  }
  .el-table__cell {
    padding: 0;
  }
}
/deep/.el-table__expand-column .cell {
  width: 0;
  height: 0;
  display: none;
}
.box-card {
  flex: 1;
  width: 100%;
  background-color: #032f79;
  border: 1px dashed #3a79e6;
  color: #fff;
  margin-bottom: 10px;
  .jc-item {
    margin-bottom: 4px;
    font-family: SimHei;
  }
}
.jc-title {
  font-size: 16px;
  font-family: SimHei;
  font-weight: 400;
  color: #fff;
  margin: 20px 0 10px;
}
.flex-space-a {
  display: flex;
  justify-content: space-around;
  align-items: center;
}
</style>
<style lang="scss">
@import './table.scss';
</style>
